unit unHostApp;

interface

uses
  Windows, Messages, SysUtils,
  {$IFDEF VER150} Variants,{$ENDIF}
  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

const
  DLLName = 'paneldll.dll';

type
  TfmHostApp = class(TForm)
    pnMenu: TPanel;
    btInit: TButton;
    btCreate: TButton;
    btShow: TButton;
    btHide: TButton;
    btRelease: TButton;
    btUnload: TButton;
    btClose: TButton;
    procedure btInitClick(Sender: TObject);
    procedure btCreateClick(Sender: TObject);
    procedure btShowClick(Sender: TObject);
    procedure btHideClick(Sender: TObject);
    procedure btReleaseClick(Sender: TObject);
    procedure btUnloadClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function InitLib(App: Integer): Boolean; external DLLName;
function CreateFM(): Boolean; external DLLName;
function ShowPN(pn: HWND): Pointer; external DLLName;
function HidePN(): Boolean; external DLLName;
function ReleaseFM(): Boolean; external DLLName;
function UnloadLib(): Boolean; external DLLName;


var
  fmHostApp: TfmHostApp;

implementation

{$R *.dfm}

procedure TfmHostApp.btInitClick(Sender: TObject);
begin
 if InitLib(Integer(Application)) then begin
  btInit.Enabled:=False;
  btCreate.Enabled:=True;
  btUnload.Enabled:=True;
 end;
end;

procedure TfmHostApp.btCreateClick(Sender: TObject);
begin
 if CreateFM then begin
  btCreate.Enabled:=False;
  btShow.Enabled:=True;
  btRelease.Enabled:=True;
  btUnload.Enabled:=False;
 end;
end;

procedure TfmHostApp.btShowClick(Sender: TObject);
var
 p: TPanel;
begin
 p:=TPanel(ShowPN(fmHostApp.Handle));
 p.Parent:=fmHostApp;
 btShow.Enabled:=False;
 btHide.Enabled:=True;
end;

procedure TfmHostApp.btHideClick(Sender: TObject);
begin
 if HidePN then begin
  btShow.Enabled:=True;
  btHide.Enabled:=False;
 end;
end;

procedure TfmHostApp.btReleaseClick(Sender: TObject);
begin
 if ReleaseFM then begin
  btCreate.Enabled:=True;
  btShow.Enabled:=False;
  btHide.Enabled:=False;
  btRelease.Enabled:=False;
  btUnload.Enabled:=True;
 end;
end;

procedure TfmHostApp.btUnloadClick(Sender: TObject);
begin
 if UnloadLib then begin
  btInit.Enabled:=True;
  btCreate.Enabled:=False;
  btUnload.Enabled:=False;
 end;
end;

procedure TfmHostApp.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
 if btRelease.Enabled then btReleaseClick(Self);
 if btUnload.Enabled then btUnloadClick(Self);
end;

procedure TfmHostApp.btCloseClick(Sender: TObject);
begin
 Close;
end;

end.
